from App.Common import package_home
from StringIO import StringIO
from Products.CMFCore.utils import getToolByName, minimalpath
from Products.CMFCore.TypesTool import ContentFactoryMetadata
from Products.CMFCore.DirectoryView import addDirectoryViews, createDirectoryView
from Products.CMFOODocument import oodocument_globals as skins_globals
from Products.CMFOODocument import ftypes
import string


def install(self):
    """ run this method to install CMFOODocument to your portal """
    out=StringIO()

    if not hasattr(self, "_isPortalRoot"):
        print >> out, "CMFOODocument must be installed into a CMF Site"
        return out.getvalue()

    print >> out, "Installing CMF OpenOffice.org Document"
    print >> out, "========================================\n"

    # add CMFOODocument to types tool
    portal_types = getToolByName(self, 'portal_types')
    for f in ftypes:
        if f['id'] not in portal_types.objectIds():
            cfm = apply(ContentFactoryMetadata, (), f)
            portal_types._setObject(f['id'], cfm)
            print >> out, 'Registered "%s" in the types tool\n' % (f['id'])
        else:
            print >> out, 'Object "%s" already existed in the types tool' % (f['id'])
            print >> out, 'NOTE: if this is a upgrade you should probably delete the factory first\n'

    # add skins
    skinstool = getToolByName(self, 'portal_skins')
    for skinpath in ('OODocument',):

        if skinpath not in skinstool.objectIds():
            # We need to add Filesystem Directory Views for any directories
            # in our skins/ directory.  These directories should already be
            # configured.
            fp = minimalpath("%s/skins/%s" % (package_home(skins_globals), skinpath))
            createDirectoryView(skinstool, fp, skinpath)
            print >> out, "Added %s directory view to portal_skins\n" % skinpath
        else:
            print >> out, "%s directory view already exists in portal_skins\n" % skinpath

        # Now we need to go through the skin configurations and insert
        # skinpath into the configurations.  Preferably, this
        # should be right after where 'custom' is placed.  Otherwise, we
        # append it to the end.
        skins = skinstool.getSkinSelections()
        for skin in skins:
            path = skinstool.getSkinPath(skin)
            path = map(string.strip, string.split(path,','))
            if skinpath not in path:
                try:
                    path.insert(path.index('custom')+1, skinpath)
                except ValueError:
                    path.append(skinpath)

                path = string.join(path, ', ')
                # addSkinSelection will replace existing skins as well.
                skinstool.addSkinSelection(skin, path)
                print >> out, "Added %s to %s skin\n" % (skinpath, skin)
            else:
                print >> out, "Skipping %s skin, %s is already set up\n" % (skin, skinpath)

    return out.getvalue()
    
